#include "os.h"
#include "paging.h"
#include "kheap.h"
#define PAGESIZE  0x1000
extern ULONG placement_address;
extern heap_t* kheap;
extern page_directory_t* kernel_directory;


int main()
{
    k_clear_screen();
    gdt_install(); idt_install();
    isrs_install(); irq_install(); ODA_install();
    sti();
    timer_install();
    keyboard_install();
    paging_install();

    sleepSeconds(10);

    // Map some pages for the the kernel heap
    ULONG i = placement_address, num;
    while( i < (placement_address+0x10000) )
    {
        page_t* page = set_page(i, kernel_directory);
        num = alloc_frame( page, 0, 0 );
        printformat("alloc_frame: %x\n", num*PAGESIZE);
        i+=PAGESIZE;
    }

    sleepSeconds(10);

    // Map some pages in the heap area and create kernel heap there
    for( i=KHEAP_START; i<KHEAP_MAX; i+=PAGESIZE )
        alloc_frame( set_page(i, kernel_directory), 0, 0);

    sleepSeconds(10);


    kheap = create_heap(KHEAP_START, KHEAP_START+KHEAP_INITIAL_SIZE, KHEAP_MAX, 0, 0);

    sleepSeconds(10);

    //analyze_frames_bitset(3);
    set_cursor(0,0);
    analyze_PD_PT_Pages(19,3,kernel_directory);
	return 0;
};
