#include "kmalloc.h"
#include "paging.h"
#include "kheap.h"
extern heap_t* kheap;
extern page_directory_t* kernel_directory;

#define PAGESIZE          0x00001000     // 0x1000 = 4096 = 4K
ULONG placement_address = 0x00200000;

ULONG k_malloc(ULONG size, UCHAR align, ULONG* phys)
{
    if( kheap!=0 )
    {
        void* addr = alloc(size, align, kheap);
        if (phys != 0)
        {
            page_t* page = get_page((ULONG)addr, kernel_directory);
            *phys = page->frame_addr*PAGESIZE + ((ULONG)addr&0x00000FFF);
        }
        printformat("k_m_heap: %x\n", (ULONG)addr);
        return (ULONG)addr;

    }
    if( align == 1 )
    {
        if( !(placement_address == (placement_address & 0xFFFFF000) ) )
        {
            placement_address &= 0xFFFFF000;
            placement_address += PAGESIZE;
        }
    }
    if( phys )
    {
        *phys = placement_address;
    }

    ULONG temp = placement_address;
    placement_address += size;     // new placement_address is increased

    printformat("old: %x sz: %x a: %d new: %x\n", temp, size, align, placement_address);
    sleepSeconds(3);

    return temp;                   // old placement_address is returned
 }

